.TH MYSQLFS 1
.SH NAME
mysqlfs \- MySQL database client
.SH SYNOPSIS
.B mysqlfs
[
.B -a
] [
.B -b
] [
.B -k
.I param=value ...
] [
.B -m
] 
.I mntpt
[
.B -s
] 
.I srvname
[
.B -v
] 
.I host ...
.sp 0.7v
.nf
.B /mnt/db/processes
.B /mnt/db/databases
.B /mnt/db/clone
.BI /mnt/db/ n
.BI /mnt/db/ n /ctl
.BI /mnt/db/ n /query
.BI /mnt/db/ n /data
.fi
.PP
.B Mysqlfs
generates a syntetic file hierarchy which allows client programs
to share a single connection to a MySQL database. This hierarchy
contains several files and directories:
.TP
.I databases
.br
A list of databases available on the server,
one per line. In common with other files generated by
.I mysqlfs
each read of
.I databases
file returns only one line.
.TP
.I processes
.br
A one line heading followed by a list of database
server process information, one line per process. 
.TP
.I clone
When this is opened a new session is allocated, when read it
contains the text of the session index; and the file
descriptor becomes that of the
.I ctl
file in the session directory.
Session directories are named by the named session index
as a decimal number, and are created on demand.
.TP
.I query
.br
commands sent to the database server in SQL.
.I query
.br
.TP 
.I data
.br
reply table from the database server from the previous query submitted.
.TP
.I ctl
control messages may be written which provide context
for queries and modify the formatting of replies.
.PP
The following messages may be written to the
.I ctl
file:
.TP
.B use database
.br
Select the database to use for queries on this session. A
.B use
command must be written to the
.I ctl
file before any queries may be submitted.
.TP
.B headings
.br
Prepend all results read from the
.I data
file with the column headings.
.TP 
.B noheadings
.br
Disable column headings.
.TP
.B padded
.br
Results colums are padded with whitespace to ensure
they align correctly.
.TP
.B delimited
.br
Results columns are not padded but are delimited with
an unlikely character. 
.TP
.B colsep ch
.br
Set the column seperator to
.IR cb ,
the default is the pipe symbol (|).
.TP
.B rowsep ch
Set the row seperator to
.IR ch ,
the default is a newline character (\\n).
.SH EXAMPLE
.EX
.SM
.SM
#!/bin/rc

rfork en

who=$1
mnt=/n/phonebook

mysqlfs -m $mnt phoneserver

{
 d=$mnt^/`{cat}

 echo headings > $d/ctl
 echo use phonesearch > $d/ctl
 echo SELECT name, num FROM tel WHERE name LIKE ''''%^$who^%'''' > $d/query
 cat $d/data
} < $mnt^/clone
.EE
.SH BUGS
The MySQL protocol used in servers before V4.1 is not supported, though
fall-back authentication for servers holding pre V4.1 passwords is provided.
